// pdf2tif.cpp : Defines the entry point for the application.
//

#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <commdlg.h>

#include <time.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include <stdlib.h>

#include <string>
#include <vector>
using namespace std;

extern "C" __declspec(dllexport) 
int __stdcall PDFToImageConverter(const char *szPDFFileName, const char *szOutputName,
			       const char *szUserPassword, const char *szOwnPassword,
			       int xresolution, int yresolution, int bitcount, 
			       int compression, int quality, BOOL grayscale, 
			       BOOL multipage,  int firstPage,int lastPage);
extern "C" __declspec(dllexport) 
int __stdcall PDFToImageConverterEx(const char *szPDFFileName, const char *szOutputName,
			       const char *szUserPassword, const char *szOwnPassword, int nIsWidthAndHeight,
			       int xResORWidth, int yResORHeight, int bitcount, 
			       int compression, int quality, int grayscale, 
			       int multipage,  int firstPage,int lastPage);
extern "C" __declspec(dllexport) 
int __stdcall PDFToImageConverter2(const char *szPDFFileName, const char *szOutputName,
			       const char *szUserPassword, const char *szOwnPassword,
			       int xresolution, int yresolution, int bitcount, 
			       int compression, int quality, BOOL grayscale, 
			       BOOL multipage,  int firstPage,int lastPage);
extern "C" __declspec(dllexport) 
int __stdcall PDFToImageConverter2Ex(const char *szPDFFileName, const char *szOutputName,
			       const char *szUserPassword, const char *szOwnPassword, int nIsWidthAndHeight,
			       int xResORWidth, int yResORHeight, int bitcount, 
			       int compression, int quality, int grayscale, 
			       int multipage,  int firstPage,int lastPage);
extern "C" __declspec(dllexport)
void __stdcall PDFToImageSetParameters(const char *parms);
extern "C" __declspec(dllexport) 
int __stdcall PDFToImageGetPageCount(const char *szPDFFileName);
extern "C" __declspec(dllexport)
HBITMAP __stdcall PDFToImageDrawToHDC(const char *szPDFFileName, HDC hDC, const char *szUserPassword, 
		    const char *szOwnPassword, int xresolution, int yresolution, 
		    int m_iBitCount, BOOL m_bGrayscale, int m_iPageIndex);
extern "C" __declspec(dllexport)
BOOL __stdcall PDFToImageDrawToHDC2(LPBYTE lpPDFData, int nPDFDataLen, HDC hDC,
									int nXDest, int nYDest, int nWidth, int nHeight,
									const char *szUserPassword, const char *szOwnPassword, int xRes, int yRes,
									int nBitCount, BOOL bGrayscale, int nPageIndex);
extern "C" __declspec(dllexport)
int __stdcall PDFToImageGetPageBox(const char *inputPDFFile, int page, double *extent);
extern "C" __declspec(dllexport)
int __stdcall PDFToImageGetPageWidth(const char *inputPDFFile, int page);
extern "C" __declspec(dllexport)
int __stdcall PDFToImageGetPageHeight(const char *inputPDFFile, int page);
typedef int (__stdcall *PDFToImageProgressCBFunc)(void *, UINT Msg, WPARAM wParam, LPARAM lParam);
extern "C" __declspec(dllexport)
void __stdcall PDFToImageSetProgressCBFunc(PDFToImageProgressCBFunc newFunc);
extern "C" __declspec(dllexport)
void __stdcall PDFToImageSetFileNameSuffix(const char *ptrFileNameSuffix);
extern "C" __declspec(dllexport)
void __stdcall PDFToImageSetCode(const char *lpRegcode);
extern "C" __declspec(dllexport)
void __stdcall PDFToImageEnableErrorDiffusion(BOOL bEnable);

LPBYTE LoadFileIntoMemory(LPCSTR lpFileName,int& nLength)
{
	LPBYTE data = NULL;
	size_t size;
	FILE *fp;
	fp = fopen(lpFileName, "rb");
	if (fp == NULL)
		return NULL;
	fseek(fp, 0, SEEK_END);
	size = ftell(fp);
	data = (unsigned char *)malloc(size);
	fseek(fp, 0, SEEK_SET);
	fread(data, 1, size, fp);
	fclose(fp);
	nLength = size;
	return data;
}
void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}

void main(int argc, char *argv[])
{
	if(argc != 2)
	{
		printf("showpdf.exe <pdf file>\n");
		return;
	}
	char *szPDFFileName = argv[1];
	BOOL bRet = FALSE;
	int nLength = 0;
	LPBYTE lpData = LoadFileIntoMemory(szPDFFileName,nLength);
	if(!lpData)
		return;
	//Set your registration key at here
	PDFToImageSetCode("XXXXXXXXXXXXXXXXXXXXX");
	PDFToImageEnableErrorDiffusion(TRUE);

	int pagecount = PDFToImageGetPageCount(szPDFFileName);
	for(int page = 1; page <= pagecount; page++)
	{
		printf("Showing %d page...\n", page);
		HDC hDC = GetDC(NULL);
		BOOL bRet = PDFToImageDrawToHDC2(lpData, nLength, hDC, 0, 0, 600, 600, NULL, NULL, 72, 72, 24, FALSE, page);
		ReleaseDC(NULL, hDC);
		Sleep(500);
	}
	return;
}